Ticket #39766

Support gratuitous GCC dependencies

Date d'ouverture: 2019-11-16 04:44 Dernière mise à jour: 2020-04-27 19:23

Rapporteur:
Propriétaire:
État:
Atteints
Composant:
Priorité:
5 - moyen
Sévérité:
5 - moyen
Résolution:
Fixed
Fichier:
1
Vote
Score: 0
No votes
0.0% (0/0)
0.0% (0/0)

Détails

MS-Windows builds of GCC-9.x gratuitously require Microsoft's non-standard _get_errno() and _set_errno() functions, which are not supported by MSVCRT.DLL prior to Windows-Vista. Additionally, this same GCC version introduces a dependency on a ftruncate64() function, which, as ftruncate() is mapped to Microsoft's _chsize(), could be mapped to Microsoft's _chsize_s(); however, like the two non-standard errno accessors, _chsize_s() is unsupported, without introducing dependencies on non-free Microsoft DLLs, prior to Windows-Vista. Such gratuitous GCC dependencies are incompatible with MinGW.org's policy of continuing legacy support for pre-Vista Windows versions.

The attached patch offers work-arounds for each of these gratuitous GCC dependencies, extending support to pre-Vista Windows, while still linking with MSVCRT.DLL.

Ticket History (3/6 Histories)

2019-11-16 04:44 Updated by: keith
  • New Ticket "Support gratuitous GCC dependencies" created
2020-01-19 01:24 Updated by: keith
Commentaire

I've addressed the two issues, as noted in the ticket submission, by way of commit #3130b13, and commit #9b6ff66.

A further issue, which arises in the Ada sockets API for GCC-9.x, is that the getaddrinfo(), getnameinfo(), and freeaddrinfo() functions are now gratuitously assumed to be available, where in reality, Microsoft's universally available WS2_32.DLL didn't support them before the release of WinXP; (they were available on Win2K, in WSHIP6.DLL, for users who had installed Win2K's IPv6 technology preview package). For earlier versions of Windows, they could be obtained, to the extent that they are applicable for IPv4 only, by inclusion of the supplementary <wspiapi.h> header, in addition to <ws2tcpip.h>; however, MinGW.org lacks an implementation of any such supplementary header. I shall work up such an implementation, to mitigate this omission.

2020-01-19 01:38 Updated by: keith
  • Propriétaire Update from (Aucun) to keith
  • Résolution Update from Aucun to Accepted
  • Jalon Update from (Aucun) to WSL-5.3 (atteints)
2020-03-01 09:01 Updated by: None
2020-04-27 19:23 Updated by: keith
  • État Update from Ouvert to Atteints
  • Résolution Update from Accepted to Fixed
Commentaire

As of the release of wsl-5.3, all gratuitously assumed features needed to support building of GCC-9.2.0 have been incorporated, for mingw32.

Attachment File List

Modifier

Please login to add comment to this ticket » Connexion